@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:doFlashSuper
set /A failure_count=0

    if "%device_has_system%" EQU "1" (
        if exist system.img (
            echo.
            echo. ------ Flashing System image ------
            %fastboot% -s %serial_number% flash system%slotsuffix% system.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash system failed^^!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Fatal Error: Different formats System image exists at the same time, this is obviously wrong, please check^^!
        )
    )

    if "%device_has_vendor%" EQU "1" (
        if exist system.img (
            echo.
            echo. ------ Flashing Vendor image ------
            %fastboot% -s %serial_number% flash vendor%slotsuffix% vendor.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Fatal Error: fastboot flash vendor failed^^!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: Vendor image does not exist, but your device contain this partition, skipping flash...
        )
    )

    if "%device_has_product%" EQU "1" (
        if exist product.img (
            echo.
            echo. ------ Flashing Product image ------
            %fastboot% -s %serial_number% flash product%slotsuffix% product.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash product failed^^!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: Product image does not exist, but your device contain this partition, skipping flash...
        )
    )

    if "%device_has_oem%" EQU "1" (
        if exist oem.img (
            echo.
            echo. ------ Flashing OEM image ------
            %fastboot% -s %serial_number% flash oem%slotsuffix% oem.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash oem failed^^!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: OEM image does not exist, but your device contain this partition, skipping flash...
        )
    )

exit /b 0
